{   This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   ---------------------------------------------------------------------------

    Messages localisation unit
    Author : Luc DAVID Email: luckylazarus@free.fr
    Copyright (C) 2006

   --------------------------------------------------------------------------- }
   
unit CreateNewIndex;
 {$IFDEF FPC}
  {$mode DELPHI}
 {$ENDIF}
interface

uses
 {$IFDEF FPC}
  Buttons, LResources,
 {$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, SQLitePassDboTest, db, SQLitePassDbo;

type
  TFormCreateNewIndex = class(TForm)
    Panel1: TPanel;
    ComboBoxTableList: TComboBox;
    Image1: TImage;
    EditIndexName: TEdit;
    BtImageIndexNew: TImage;
    ScrollBoxIndexedFields: TScrollBox;
    Panel2: TPanel;
    Image7: TImage;
    CheckBoxUniqueIndex: TCheckBox;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    ImageDescending: TImage;
    ImageAscending: TImage;
    procedure ButtonOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  public
    ACbIndexedFields: Array[0..99] of TCheckBox;
    AImIndexDirection: Array[0..99] of TImage;
    Procedure OnCbIndexedFieldClick(Sender: TObject);
    procedure OnImIndexDirectionClick(Sender: TObject);
  private
    Function  FindCbIndexedField(Cb : TCheckBox):Integer;
    Function  FindImIndexDirection(Im : TImage):Integer;
    procedure RefreshIndexDefinition;
  public
    { Dclarations publiques }
  end;

var
  FormCreateNewIndex: TFormCreateNewIndex;

implementation
 {$IFNDEF FPC}
   {$R *.DFM}
 {$ENDIF}

uses MainUnit;

procedure TFormCreateNewIndex.OnCbIndexedFieldClick(Sender: TObject);
begin
FormCreateNewIndex_DoOnCbIndexedFieldClick(Sender);
end;

procedure TFormCreateNewIndex.OnImIndexDirectionClick(Sender: TObject);
begin
FormCreateNewIndex_DoOnImIndexDirectionClick(Sender);
end;

procedure TFormCreateNewIndex.RefreshIndexDefinition;
begin
FormCreateNewIndex_DoRefreshIndexDefinition;
end;


Function TFormCreateNewIndex.FindCbIndexedField(Cb : TCheckBox):Integer;
begin
FormCreateNewIndex_DoFindCbIndexedField(Cb);
end;

Function TFormCreateNewIndex.FindImIndexDirection(Im : TImage):Integer;
begin
FormCreateNewIndex_DoFindImIndexDirection(Im);
end;

procedure TFormCreateNewIndex.ButtonOkClick(Sender: TObject);
begin
FormCreateNewIndex_DoButtonOkClick(Sender);
end;

procedure TFormCreateNewIndex.FormShow(Sender: TObject);
begin
FormCreateNewIndex_DoFormCreate;
end;


initialization
 {$IFDEF FPC}
  {$I CreateNewIndex.lrs}
 {$ENDIF}
end.
