{   This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  ---------------------------------------------------------------------------

    SqlitePass Database Objects Package
    Registration unit
    Author : Luc DAVID Email: luckylazarus@free.fr
    Copyright (C) 2006

  ---------------------------------------------------------------------------

    20.07.2006 - V0.20
      First public release. For testing and debuging.

  --------------------------------------------------------------------------- }


unit RegisterSqlitePassDbo;

{$i SqlitePassDbo.inc}

{$IFNDEF FPC}
{$R D4_SqlitePassDbo.dcr}
{$ENDIF}
interface

uses

{$IFDEF FPC}
 LResources, PropEdits, LazarusPackageIntf, Buttons,
{$ELSE}
 DsgnIntf,
{$ENDIF}
 Classes, SysUtils, Forms, Controls, ComCtrls, StdCtrls, ExtCtrls, SqlitePassDbo;

Type
TDatasetNameEditor = class(TStringProperty)
    Public
      Procedure Edit;override;
      Procedure SetValue(const Value: string); override;
      Function  GetAttributes: TPropertyAttributes; override;
    End;

procedure Register;

implementation
procedure Register;
Begin
 RegisterComponents('SqlitePassDbo', [TSqlitePassDatabase, TSqlitePassDataset]);

 { TSqlitePassDatabase }
 {$IFDEF FPC}
  RegisterPropertyEditor(TypeInfo(String),TSqlitePassDatabase,'Database',TFileNamePropertyEditor);
 {$ENDIF}

 { TSqlitePassDataset }
 RegisterPropertyEditor(TypeInfo(String),TSqlitePassDataset,'DatasetName',TDatasetNameEditor);
End;


Function TDatasetNameEditor.GetAttributes: TPropertyAttributes;
begin
   Result:= [paDialog];
end;


Procedure TDatasetNameEditor.SetValue(const Value: string);
Begin
if GetComponent(0) is TSqlitePassDataset then
  Begin
    inherited SetValue(Value);
    Modified;
  End;
End;

procedure TDatasetNameEditor.Edit;
var
 Dataset: TSqlitePassDataset;
 Db: TSqlitePassDatabase;
 F: TForm;
 PanelTop, PanelCenter, PanelBottom : TPanel;
 Tv : TTreeView;
 BtOk, BtCancel : TButton;
 i: Integer;
 DatabaseNode, TablesNode, QueriesNode, SystemTablesNode: TTreeNode;
Begin
 Dataset:=TSqlitePassDataset(GetComponent(0));
 if not Assigned(Dataset) then exit;
 Db := Dataset.Database;
 if not Assigned(Db) then exit;

 F := TForm.Create(Nil);

 With F do begin
 Caption := ' Choose a dataset';
 Width := 350;
 Height := 400;
 Position := poScreenCenter;
 end;

 PanelTop := TPanel.Create(F);
 PanelTop.Parent := F;
 PanelTop.Align := alTop;

 PanelCenter := TPanel.Create(F);
 PanelCenter.Parent := F;
 PanelCenter.Align := alClient;

 PanelBottom := TPanel.Create(F);
 PanelBottom.Parent := F;
 PanelBottom.Align := alBottom;

 Tv := TTreeView.Create(F);
 Tv.Parent := PanelCenter;
 Tv.Align := alClient;

 BtOk := TButton.Create(F);
 With BtOk do Begin
 Parent := PanelBottom;
 Top := 10;
 Left := 150;
 Caption := '&Ok';
 ModalResult := mrOk;
 end;

 BtCancel := TButton.Create(F);
 With BtCancel do begin
 Parent := PanelBottom;
 Top := 10;
 Left := 250;
 Caption := '&Cancel';
 ModalResult := mrCancel;
 end;

Tv.Items.Clear;
DatabaseNode:=Tv.Items.Add(nil,'Database');
TablesNode  := Tv.Items.AddChild(DatabaseNode,'Tables');
QueriesNode := Tv.Items.AddChild(DatabaseNode,'Queries');
SystemTablesNode := Tv.Items.AddChild(DatabaseNode,'System Tables');
Db.RefreshDefinitions;
for i:= 0 to Pred(Db.TableDefs.Count)
   do Tv.Items.AddChild(TablesNode,Db.TableDefs[i].TableName);

for i:= 0 to Pred(Db.QueryDefs.Count)
   do Tv.Items.AddChild(QueriesNode,Db.QueryDefs[i].QueryName);

Tv.FullExpand;
if (F.ShowModal = mrOk)
   then begin
        Dataset.Close;
        SetStrValue(Tv.Selected.Text);
        end;
F.Free;
End;

initialization
{$IFDEF FPC}
 {$i SqlitePassDbo.lrs}
{$ENDIF}
end.
